variables:
    DOCKER_IMAGE_NAME: "$CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG"
    HELM_NAME: "golemio"
    K8S_DEPLOYMENT_NAME: "tcp-input-gateway"
    K8S_DEPLOYMENT_IMAGE_TAG: $CI_PIPELINE_ID

stages:
    - test
    - build
    - release
    - deploy

include:
    - template: "Workflows/Branch-Pipelines.gitlab-ci.yml"
    - project: "operator-ict/devops/gitlab-ci-pipeline"
      file:
          - "/docker/simple-build.yml"
          - "/k8s-golemio/helm-golemio-deploy.yml"

cache:
    key:
        files:
            - package-lock.json
    paths:
        - node_modules
        - .eslintcache

.run_tests:
    stage: test
    coverage: /All files[^|]*\|[^|]*\s+([\d\.]+)/
    script:
        - npm install --ignore-scripts --progress=false
        # Audit production dependencies for HIGH vulnerabilities
        - npm audit --omit dev --audit-level high
        - npm run lint
        - npm run build
        - npm run code-coverage
    artifacts:
        when: always
        reports:
            junit:
                - junit.xml
            coverage_report:
                coverage_format: cobertura
                path: coverage/cobertura-coverage.xml

    tags:
        - docker
    rules:
        - when: always

run_tests:
    extends: .run_tests
    image: node:20.18.0-alpine

# run_tests-node-next:
#     extends: .run_tests
#     image: node:22.1.0-alpine
#     allow_failure: true
